# tftpboot

1. [Overview](#overview)
2. [Description](#description)
    * [PXE files](#pxe-files)
    * [Configuration files](#configuration-files)
    * [Preseed](#preseed)
    * [Scripts](#scripts)
3. [How to use it](#how-to-use-it)
4. [TODO](#todo)

## Overview

All needed files to set up a PXE servers.

## Description

### PXE files
Use some bootloaders files provide by :
  * `pxelinux` debian package :
    * gpxelinux.0
    * pxelinux.0
  * `syslinux-common` debian package :
    * chain.c32
    * menu.c32
    * reboot.c32
    * vesamenu.c32

### Configuration files
Contains the files which defines the PXE menu. The [first one][main menu.cfg] will :
  * Call all others menu.cfg from subdirectories (debian/, clonezilla/,…) as an entry.
  * Define a timeout (4 seconds).
  * Define the default entry (boot on local first disk).
  * …

#### config/debian/menu.cfg
1. Provide PXE entry for :
  * Debian Wheezy (oldStable) amd64
  * Debian Wheezy (oldStable) i386
  * Debian Wheezy (oldStable) amd64 with additionnals firmwares (see [make_debian_initrd_with_firmware.sh][debian initrd with firmware script] script)
  * Debian Wheezy (oldStable) amd64 with additionnals firmwares and preseed file
  * Debian Wheezy (oldStable) amd64 for minions with preseed (Gnome 3 as default GUI)
  * Debian Jessie (Stable) amd64
  * Debian Jessie (Stable) amd64 with preseed file
  * Debian Jessie (Stable) amd64 for minions with preseed (Gnome 3 as default GUI)
  * Debian Jessie (Stable) amd64 for minions with preseed (Mate as default GUI)
  * Debian Jessie (Stable) amd64 for minions with preseed (Cinnamon as default GUI)
  * Debian Sid (unstable) amd64
  * Debian Sid (unstable) amd64 with additionnals firmwares
  * Debian Sid (unstable) i386

### Preseed

### Scripts

See the [scripts's README.md][scripts readme.md] file for more informations.

## How to use it

  * Put the data of this repository on the PXE server :
    * Clone the repository with https URL or with SSH to **/var/lib/tftpboot**.
    * Download the last archive : `wget https://git.ipr.univ-rennes1.fr/cellinfo/tftpboot/archive/master.tar.gz`
  * Install a TFTP server (`tftpd-hpa` package for Debian's based systems or `tftp-server` for Redhat's based systems).
  * Start the tftpd's service :
    * `sudo service tftpd-hpa start`
    * `sudo systemctl start tftpd-hpa`
  * You can test if the TFTP server provide the files with a TFTP client (`tftp-hpa`) by downloading a file with the command :
    * `tftp $IP.SRV.TFTP -c get README.md /tmp/README.md_from_tftpd_server`

## TODO
  * Add a tiny preseed file that could be load for a manual install.





[main menu.cfg]: ./config/menu.cfg
[scripts readme.md]: https://git.ipr.univ-rennes1.fr/cellinfo/tftpboot/src/master/scripts "scripts's README.md for tftpboot"
[debian initrd with firmware script]: ./scripts/README.md#make_debian_initrd_with_firmwaresh "informations about the Debian's initrd with additionnals firmwares"
